<template>
  <div v-if="promotions.length > 0">
    <div class="promotion-swiper mx-auto relative">
      <swiper
        :loop="promotions.length > 7"
        :slides-per-view="promotions.length < 4 ? promotions.length : 4"
        :navigation="promotions.length > 4"
        :modules="modules"
      >
        <template
          v-for="(promotion, index) in _.sortBy(
            promotions,
            'DisplayOrder'
          ).slice(0, 10)"
          :key="index"
        >
          <swiper-slide class="flex justify-center">
            <nuxt-link :to="`/promotion/${promotion.Id}`">
              <div
                class="pointer w-[287px] h-[123px] flex-none order-[0] flex-grow-0 rounded-[8px] overflow-hidden"
              >
                <img
                  v-lazy="promotion.ImagePathForDisplay"
                  :alt="promotion.Title"
                  class="w-full h-full object-cover rounded-[8px] hover:scale-105 duration-500"
                />
              </div>
            </nuxt-link>
          </swiper-slide>
        </template>
      </swiper>
      <div
        class="btn-prev-carousel cus-swiper-button-prev"
        @click="handleClick1"
      >
        <div class="play"></div>
      </div>
      <div
        class="btn-next-carousel cus-swiper-button-next"
        @click="handleClick"
      >
        <div class="play"></div>
      </div>
    </div>
  </div>
</template>

<script setup lang="ts">
import _ from "lodash";
import { Navigation, Pagination } from "swiper";

const { promotions } = usePromotion();
// const promotionForDisplay = computed(() =>
//   _.sortBy(promotions, "DisplayOrder").slice(0, 10)
// );
const modules = [Navigation, Pagination];

const handleClick = () => {
  // @ts-ignore
  document.querySelector(".promotion-swiper .swiper-button-next").click();
};
const handleClick1 = () => {
  // @ts-ignore
  document.querySelector(".promotion-swiper .swiper-button-prev").click();
};
</script>

<style lang="scss">
.promotion-swiper {
  .swiper {
    overflow: hidden;
  }
  .swiper-button-prev,
  .swiper-button-next {
    display: none;
  }

  .cus-swiper-button-prev {
    position: absolute;
    left: 0;
    top: calc(50% - 15px);
    z-index: 20;
  }

  .cus-swiper-button-next {
    position: absolute;
    z-index: 20;
    right: 4px;
    top: calc(50% - 15px);
  }
  .btn-next-carousel,
  .btn-prev-carousel {
    background: var(--background5);
    height: 30px;
    width: 30px;
    border-radius: 50%;
    border: 3px solid var(--background1);
    bottom: 0%;
    box-shadow: 0px 4px 4px rgba(0, 0, 0, 0.25);
    display: flex;
    justify-content: center;
    align-items: center;
    cursor: pointer;
  }
  .btn-next-carousel {
    .play {
      border-color: transparent transparent transparent var(--primary);
      border-width: 6px 0 6px 12px;
      margin-left: 3px;
    }
  }

  .btn-prev-carousel {
    .play {
      border-color: transparent transparent transparent var(--primary);
      border-width: 6px 0 6px 12px;
      margin-right: 3px;
      transform: rotate(180deg);
    }
  }
}
</style>
